searchNodes=[{"type":"module","title":"ICPAgent","doc":"This module provides a client for the ICP protocol. Query example This examples uses the get_latest_sns_version_pretty method from the SNS-wasm system canister. It's a publicly available method, so no authentication is needed. We're generating a new wallet ad-hoc and using it to query the canister. &gt; [ versions ] = ICPAgent . query ( &quot;qaa6y-5yaaa-aaaaa-aaafa-cai&quot; , DiodeClient.Wallet . new ( ) , &quot;get_latest_sns_version_pretty&quot; ) [ [ { &quot;Ledger Index&quot; , &quot;2adc74fe5667f26ea4c4006309d99b1dfa71787aa43a5c168cb08ec725677996&quot; } , { &quot;Governance&quot; , &quot;bd936ef6bb878df87856a0b0c46034a242a88b7f1eeff5439daf6278febca6b7&quot; } , { &quot;Ledger Archive&quot; , &quot;f94cf1db965b7042197e5894fef54f5f413bb2ebc607ff0fb59c9d4dfd3babea&quot; } , { &quot;Swap&quot; , &quot;8313ac22d2ef0a0c1290a85b47f235cfa24ca2c96d095b8dbed5502483b9cd18&quot; } , { &quot;Root&quot; , &quot;431cb333feb3f762f742b0dea58745633a2a2ca41075e9933183d850b4ddb259&quot; } , { &quot;Ledger&quot; , &quot;25071c2c55ad4571293e00d8e277f442aec7aed88109743ac52df3125209ff45&quot; } ] ] Call example Calls and queries both support providing arguments and types in Candid format specification. These are some examples of call structures to give a better understanding of how the types are specified. # Generating a new private key as identity &gt; wallet = DiodeClient.Wallet . new ( ) # Call with passing two blobs as an argument &gt; [ 200 ] = ICPAgent . call ( canister_id , wallet , &quot;test_blob_input&quot; , [ :blob , :blob ] , [ &quot;blob_a&quot; , &quot;blob_b&quot; ] ) # Call with passing a record as an argument &gt; [ 3 ] = ICPAgent . call ( canister_id , wallet , &quot;test_record_input&quot; , [ { :record , { :nat32 , :nat32 } } ] , [ { 1 , 2 } ] ) # Call with passing a record with named fields as an argument &gt; [ 3 ] = ICPAgent . call ( canister_id , wallet , &quot;test_named_record_input&quot; , [ { :record , %{ a : :nat32 , b : :nat32 } } ] , [ { a : 1 , b : 2 } ] ) # Call with passing a vector of records as an argument &gt; [ 200 ] = ICPAgent . call ( canister_id , wallet , &quot;test_vec_input&quot; , [ { :vec , { :record , { :blob , :blob } } } ] , [ [ { &quot;blob_a&quot; , &quot;blob_b&quot; } ] ] ) Limits Only secp256k1 keys are supported. Did files are not supported and instead types for a call/query must be manually specified.","ref":"ICPAgent.html"},{"type":"function","title":"ICPAgent.call/5","doc":"","ref":"ICPAgent.html#call/5"},{"type":"function","title":"ICPAgent.crc32/1","doc":"This function computes the CRC32 checksum of a binary.","ref":"ICPAgent.html#crc32/1"},{"type":"function","title":"ICPAgent.decode_textual/1","doc":"This function decodes a textual representation of an ICP Principal identifier into a binary representation. Example iex&gt; ICPAgent . decode_textual ( &quot;bkyz2-fmaaa-aaaaa-qaaaq-cai&quot; ) &lt;&lt; 128 , 0 , 0 , 0 , 0 , 16 , 0 , 1 , 1 , 1 &gt;&gt;","ref":"ICPAgent.html#decode_textual/1"},{"type":"function","title":"ICPAgent.default_canister_id/0","doc":"","ref":"ICPAgent.html#default_canister_id/0"},{"type":"function","title":"ICPAgent.default_host/0","doc":"","ref":"ICPAgent.html#default_host/0"},{"type":"function","title":"ICPAgent.domain_separator/1","doc":"","ref":"ICPAgent.html#domain_separator/1"},{"type":"function","title":"ICPAgent.encode_textual/1","doc":"","ref":"ICPAgent.html#encode_textual/1"},{"type":"function","title":"ICPAgent.h/1","doc":"Implementation of the ICP hash function. It is in the ICP docs usually referred to as H() . https://internetcomputer.org/docs/current/references/ic-interface-spec","ref":"ICPAgent.html#h/1"},{"type":"function","title":"ICPAgent.hash_of_map/1","doc":"Implementation of the ICP hash function for a map. It is in the ICP docs usually referred to as hash_of_map . https://internetcomputer.org/docs/current/references/ic-interface-spec#request-id","ref":"ICPAgent.html#hash_of_map/1"},{"type":"function","title":"ICPAgent.host/0","doc":"","ref":"ICPAgent.html#host/0"},{"type":"function","title":"ICPAgent.print_requests?/0","doc":"","ref":"ICPAgent.html#print_requests?/0"},{"type":"function","title":"ICPAgent.query/5","doc":"This function queries a canister using the ICP query protocol. Example: &gt; [ versions ] = ICPAgent . query ( &quot;qaa6y-5yaaa-aaaaa-aaafa-cai&quot; , DiodeClient.Wallet . new ( ) , &quot;get_latest_sns_version_pretty&quot; )","ref":"ICPAgent.html#query/5"},{"type":"function","title":"ICPAgent.read_state/3","doc":"","ref":"ICPAgent.html#read_state/3"},{"type":"function","title":"ICPAgent.status/0","doc":"","ref":"ICPAgent.html#status/0"},{"type":"function","title":"ICPAgent.utf8_to_list/1","doc":"","ref":"ICPAgent.html#utf8_to_list/1"},{"type":"function","title":"ICPAgent.wallet_der/1","doc":"This function converts a DiodeClient.Wallet.t() into a DER encoded binary representation of the public key. The DER encoded binary representation is the canonical form as used by the ICP in various protocol interactions.","ref":"ICPAgent.html#wallet_der/1"},{"type":"function","title":"ICPAgent.wallet_from_pem/1","doc":"This function converts a PEM encoded binary representation of a Secp256k1 curve private key into a DiodeClient.Wallet.t().","ref":"ICPAgent.html#wallet_from_pem/1"},{"type":"function","title":"ICPAgent.wallet_id/1","doc":"This function converts a DiodeClient.Wallet.t() into a binary representation of the public ICP Principal identifier. https://internetcomputer.org/docs/current/references/ic-interface-spec#id-classes","ref":"ICPAgent.html#wallet_id/1"},{"type":"function","title":"ICPAgent.wallet_private_pem/1","doc":"","ref":"ICPAgent.html#wallet_private_pem/1"},{"type":"function","title":"ICPAgent.wallet_sign/2","doc":"This function signs a binary with a DiodeClient.Wallet.t() using the secp256k1 algorithm and the ICP signing scheme.","ref":"ICPAgent.html#wallet_sign/2"},{"type":"function","title":"ICPAgent.wallet_textual/1","doc":"This function converts a DiodeClient.Wallet.t() into a textual representation of the public ICP Principal identifier.","ref":"ICPAgent.html#wallet_textual/1"},{"type":"module","title":"ICPAgent.VetKD","doc":"This module provides functions for working with Dfinity vetKeys. https://internetcomputer.org/docs/references/vetkeys-overview","ref":"ICPAgent.VetKD.html"},{"type":"function","title":"ICPAgent.VetKD.decrypt_key/2","doc":"","ref":"ICPAgent.VetKD.html#decrypt_key/2"},{"type":"function","title":"ICPAgent.VetKD.new_transport_private_key/0","doc":"","ref":"ICPAgent.VetKD.html#new_transport_private_key/0"},{"type":"function","title":"ICPAgent.VetKD.transport_private_key_to_public_key/1","doc":"","ref":"ICPAgent.VetKD.html#transport_private_key_to_public_key/1"},{"type":"extras","title":"Elixir ICP Agent for the Internet Computer","doc":"The ICP Agent library supports both queries and calls to the Internet Computer. All authentication is done using Secp256k1 keys handled by the DiodeClient.Wallet struct.","ref":"readme.html"},{"type":"extras","title":"Elixir ICP Agent for the Internet Computer - Query example","doc":"This examples uses the get_latest_sns_version_pretty method from the SNS-wasm system canister. It's a publicly available method, so no authentication is needed. We're generating a new wallet ad-hoc and using it to query the canister. &gt; [ versions ] = ICPAgent . query ( &quot;qaa6y-5yaaa-aaaaa-aaafa-cai&quot; , DiodeClient.Wallet . new ( ) , &quot;get_latest_sns_version_pretty&quot; ) [ [ { &quot;Ledger Index&quot; , &quot;2adc74fe5667f26ea4c4006309d99b1dfa71787aa43a5c168cb08ec725677996&quot; } , { &quot;Governance&quot; , &quot;bd936ef6bb878df87856a0b0c46034a242a88b7f1eeff5439daf6278febca6b7&quot; } , { &quot;Ledger Archive&quot; , &quot;f94cf1db965b7042197e5894fef54f5f413bb2ebc607ff0fb59c9d4dfd3babea&quot; } , { &quot;Swap&quot; , &quot;8313ac22d2ef0a0c1290a85b47f235cfa24ca2c96d095b8dbed5502483b9cd18&quot; } , { &quot;Root&quot; , &quot;431cb333feb3f762f742b0dea58745633a2a2ca41075e9933183d850b4ddb259&quot; } , { &quot;Ledger&quot; , &quot;25071c2c55ad4571293e00d8e277f442aec7aed88109743ac52df3125209ff45&quot; } ] ]","ref":"readme.html#query-example"},{"type":"extras","title":"Elixir ICP Agent for the Internet Computer - Call example","doc":"Calls and queries both support providing arguments and types in Candid format specification. These are some examples of call structures to give a better understanding of how the types are specified. # Generating a new private key as identity &gt; wallet = DiodeClient.Wallet . new ( ) # Call with passing two blobs as an argument &gt; [ 200 ] = ICPAgent . call ( canister_id , wallet , &quot;test_blob_input&quot; , [ :blob , :blob ] , [ &quot;blob_a&quot; , &quot;blob_b&quot; ] ) # Call with passing a record as an argument &gt; [ 3 ] = ICPAgent . call ( canister_id , wallet , &quot;test_record_input&quot; , [ { :record , { :nat32 , :nat32 } } ] , [ { 1 , 2 } ] ) # Call with passing a record with named fields as an argument &gt; [ 3 ] = ICPAgent . call ( canister_id , wallet , &quot;test_named_record_input&quot; , [ { :record , %{ a : :nat32 , b : :nat32 } } ] , [ { a : 1 , b : 2 } ] ) # Call with passing a vector of records as an argument &gt; [ 200 ] = ICPAgent . call ( canister_id , wallet , &quot;test_vec_input&quot; , [ { :vec , { :record , { :blob , :blob } } } ] , [ [ { &quot;blob_a&quot; , &quot;blob_b&quot; } ] ] )","ref":"readme.html#call-example"},{"type":"extras","title":"Elixir ICP Agent for the Internet Computer - Limits","doc":"Only secp256k1 keys are supported. Did files are not supported and instead types for a call/query must be manually specified.","ref":"readme.html#limits"},{"type":"extras","title":"Elixir ICP Agent for the Internet Computer - Installation","doc":"If available in Hex , the package can be installed by adding icp_agent to your list of dependencies in mix.exs : def deps do [ { :icp_agent , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/icp_agent .","ref":"readme.html#installation"}]